#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include "pictures.h"

//-----------------------------------------------------------------------------
// Name: getpicture
// Desc: Return the corresponding byte for the pixel
//-----------------------------------------------------------------------------

int BMP2LZW::getpicture(){
	int b = fgetc(fp);
	int g = fgetc(fp);
	int r = fgetc(fp);
	//white
	if(b == 0 && g == 0 && r == 0){
		return 0;
	}
	//dark blue
	if(b == 160 && g == 0 && r == 0){
		return 1;
	}
	//dark green
	if(b == 0 && g == 160 && r == 0){
		return 2;
	}
	//blue green
	if(b == 160 && g == 160 && r == 0){
		return 3;
	}
	//maroon
	if(b == 0 && g == 0 && r == 160){
		return 4;
	}
	//purple
	if(b == 160 && g == 0 && r == 160){
		return 5;
	}
	//brown
	if(b == 0 && g == 80 && r == 160){
		return 6;
	}
	//light grey
	if(b == 160 && g == 160 && r == 160){
		return 7;
	}
	//dark grey
	if(b == 80 && g == 80 && r == 80){
		return 8;
	}
	//blue
	if(b == 255 && g == 0 && r == 0){
		return 9;
	}
	//light green
	if(b == 80 && g == 255 && r == 80){
		return 10;
	}
	//light blue
	if(b == 255 && g == 255 && r == 80){
		return 11;
	}
	//light red
	if(b == 80 && g == 80 && r == 255){
		return 12;
	}
	//purple
	if(b == 255 && g == 80 && r == 255){
		return 13;
	}
	//yellow
	if(b == 80 && g == 255 && r == 255){
		return 14;
	}
	//white
	if(b == 255 && g == 255 && r == 255){
		return 15;
	}
	return 0;
}

//-----------------------------------------------------------------------------
// Name: getdat
// Desc: Get the bytes for the *.lzw file
//-----------------------------------------------------------------------------

void BMP2LZW::getdat(){
	int zeros = (width%4);
	for(int b=height-1;b>=0;b--){
		for(int a=0;a<width;a++){
			pixels[a][b] = getpicture();
		}
		fseek(fp,zeros,SEEK_CUR);
	}
}

//-----------------------------------------------------------------------------
// Name: getheader
// Desc: Skip the bitmap header
//-----------------------------------------------------------------------------

void BMP2LZW::getheader(){
	fseek(fp,0x36,SEEK_SET);
}

//-----------------------------------------------------------------------------
// Name: writedat
// Desc: Read the bitmap and compress 2 pixels into one byte
//-----------------------------------------------------------------------------

void BMP2LZW::writedat(){
	int x;
	int y;
	int z;
	for(int d = 0; d < numytiles; d++){
		for(int c = 0; c < numxtiles; c++){
			for(int b = 0; b < tileheight; b++){
				for(int a = 0; a < (tilewidth / 2); a++){
					x = pixels[(a*2)+(c*tilewidth)][b+(d*tileheight)];
					y = pixels[(a*2+1)+(c*tilewidth)][b+(d*tileheight)];
					z = (x << 4) + y;
					fputc(z,fw);
				}
			}
		}
	}
}

//-----------------------------------------------------------------------------
// Name: writelzw
// Desc: Write the *.lzw file
//-----------------------------------------------------------------------------

void BMP2LZW::writelzw(int width1, int height1, int tilewidth1,
				 int tileheight1, int numxtiles1, int numytiles1){
	height = height1;
	width = width1;
	tilewidth = tilewidth1;
	tileheight = tileheight1;
	numxtiles = numxtiles1;
	numytiles = numytiles1;
	getheader();
	init();
	getdat();
	writedat();
}

//-----------------------------------------------------------------------------
// Name: writetileslzw
// Desc: Open bitmaps and write tiles.lzw
//-----------------------------------------------------------------------------

void BMP2LZW::writetileslzw(){
	if((fp = fopen(".//game//pictures//tiles.bmp","rb"))==NULL){
		return;
	}
	fw = fopen(".//game//other//tiles.lzw","wb");
	writelzw(512,256,16,16,32,16);
	fclose(fp);
	fclose(fw);
}

//-----------------------------------------------------------------------------
// Name: writeultimalzw
// Desc: Open bitmaps and write ultima.lzw
//-----------------------------------------------------------------------------

void BMP2LZW::writeultimalzw(){

	if((fp = fopen(".//game//pictures//ultima.bmp","rb"))==NULL){
		return;
	}
	fw = fopen(".//game//other//ultima.lzw","wb");
	//***********************************
	//write 26 bytes
	//***********************************
	fputc(0x05,fw);
	fputc(0x00,fw);
	fputc(0x16,fw);
	fputc(0x00,fw);
	fputc(0x00,fw);
	fputc(0x00,fw);
	fputc(0x3a,fw);
	fputc(0x26,fw);
	fputc(0x00,fw);
	fputc(0x00,fw);
	fputc(0xce,fw);
	fputc(0x41,fw);
	fputc(0x00,fw);
	fputc(0x00,fw);
	fputc(0x62,fw);
	fputc(0x5d,fw);
	fputc(0x00,fw);
	fputc(0x00,fw);
	fputc(0xf6,fw);
	fputc(0x78,fw);
	fputc(0x00,fw);
	fputc(0x00,fw);
	fputc(0x3f,fw);
	fputc(0x01,fw);
	fputc(0x3d,fw);
	fputc(0x00,fw);
	//***********************************
	writelzw(320,61,320,61,1,1);
	fclose(fp);
	fp = fopen(".//game//pictures//ultima1.bmp","rb");
	//***********************************
	//write 4 bytes
	//***********************************
	fputc(0x20,fw);
	fputc(0x01,fw);
	fputc(0x31,fw);
	fputc(0x00,fw);
	//***********************************
	writelzw(288,49,288,49,1,1);
	fclose(fp);
	fp = fopen(".//game//pictures//ultima2.bmp","rb");
	//***********************************
	//write 4 bytes
	//***********************************
	fputc(0x20,fw);
	fputc(0x01,fw);
	fputc(0x31,fw);
	fputc(0x00,fw);
	//***********************************
	writelzw(288,49,288,49,1,1);
	fclose(fp);
	fp = fopen(".//game//pictures//ultima3.bmp","rb");
	//***********************************
	//write 4 bytes
	//***********************************
	fputc(0x20,fw);
	fputc(0x01,fw);
	fputc(0x31,fw);
	fputc(0x00,fw);
	//***********************************
	writelzw(288,49,288,49,1,1);
	fclose(fp);
	fp = fopen(".//game//pictures//ultima4.bmp","rb");
	//***********************************
	fputc(0x20,fw);
	fputc(0x01,fw);
	fputc(0x31,fw);
	fputc(0x00,fw);
	//***********************************
	//write 4 bytes
	//***********************************
	writelzw(288,49,288,49,1,1);
	fclose(fp);
	//***********************************
	//write 144 bytes
	//***********************************
	writezeros(0x87);
	fputc(4,fw);
	fputc(4,fw);
	fputc(4,fw);
	writezeros(6);
	fclose(fw);
}

//-----------------------------------------------------------------------------
// Name: drawdat
// Desc: Write the extracted pixels into the bitmap
//-----------------------------------------------------------------------------

void LZW2BMP::drawdat(){
	int zeros = (width%4);
	for(int b=(height - 1);b>=0;b--){
		for(int a=0;a<width;a++){
			writepicture(pixels[a][b]);
		}
		writezeros(zeros);
	}
}

//-----------------------------------------------------------------------------
// Name: writebitmap
// Desc: Draws the bitmap
//-----------------------------------------------------------------------------

void LZW2BMP::writebitmap(int width1, int height1,bool mask,
						  int numxtiles1=1, int numytiles1=1){
	height = height1;
	width = width1;
	numxtiles = numxtiles1;
	numytiles = numytiles1;
	tilewidth = (width1/numxtiles);
	tileheight = (height1/numytiles);
	writeheader();
	init();
	writedat(mask);
	drawdat();
	writeend();
}

//-----------------------------------------------------------------------------
// Name: writebmplzw1
// Desc: Opens *.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writebmplzw1(char* bmp, int num, int seek1, FILE *fp,
						   int width1, int height1, bool mask=false){
	char bmpfile[_MAX_PATH];
	fseek(fp,seek1,SEEK_CUR);
	sprintf(bmpfile,".//game//pictures//%s%d.bmp",bmp,num);
	fw = fopen(bmpfile,"wb");
	if(mask==true){
		width1*=4;
	}
	writebitmap(width1,height1,mask);
	fclose(fw);
}

//-----------------------------------------------------------------------------
// Name: writedat
// Desc: Get the data from *.ch and draw the 2 pixels
//-----------------------------------------------------------------------------

void LZW2BMP::writedat(bool mask){
	int s=2;
	int y;
	int z;
	int q[8];
	if(mask==true){
		s*=4;
	}
	for(int d = 0; d < numytiles; d++){
		for(int c = 0; c < numxtiles; c++){
			for(int b = 0; b < tileheight; b++){
				for(int a = 0; a < (tilewidth / s); a++){
					int x = fgetc(fp);
					if(mask==false){
						y = x/(0x10);
						z = x-(y*0x10);
						pixels[(a*2)+(c*tilewidth)][b+(d*tileheight)]=y;
						pixels[(a*2+1)+(c*tilewidth)][b+(d*tileheight)]=z;
					}
					else{
						for(int e=0;e<8;e++){
							q[e] = ((x>>(7-e))&1);
							if(q[e]==0){
								q[e]=0;
							}
							else{
								q[e]=15;
							}
						}
						pixels[(a*8)+(c*tilewidth)][b+(d*tileheight)]=q[0];
						pixels[(a*8+1)+(c*tilewidth)][b+(d*tileheight)]=q[1];
						pixels[(a*8+2)+(c*tilewidth)][b+(d*tileheight)]=q[2];
						pixels[(a*8+3)+(c*tilewidth)][b+(d*tileheight)]=q[3];
						pixels[(a*8+4)+(c*tilewidth)][b+(d*tileheight)]=q[4];
						pixels[(a*8+5)+(c*tilewidth)][b+(d*tileheight)]=q[5];
						pixels[(a*8+6)+(c*tilewidth)][b+(d*tileheight)]=q[6];
						pixels[(a*8+7)+(c*tilewidth)][b+(d*tileheight)]=q[7];
					}
				}
			}
		}
	}
}

//-----------------------------------------------------------------------------
// Name: writeend
// Desc: Write the bitmap end
//-----------------------------------------------------------------------------

void LZW2BMP::writeend(){
	writezeros(2);
}

//-----------------------------------------------------------------------------
// Name: writeheader
// Desc: Writes the bitmap header
//-----------------------------------------------------------------------------

void LZW2BMP::writeheader(){
	int tempwidth = width/256;
	int tempheight = height/256;
	tempwidth &= 0xff;
	tempheight &= 0xff;
	fputc(0x42,fw);
	fputc(0x4d,fw);
	writezeros(8);
	fputc(0x36,fw);
	writezeros(3);
	fputc(0x28,fw);
	writezeros(3);
	fputc((width & 0xff),fw);//The width
	fputc(tempwidth,fw);//The width
	writezeros(2);
	fputc((height & 0xff),fw);//The height
	fputc(tempheight,fw);//The height
	writezeros(2);
	fputc(0x01,fw);
	writezeros(1);
	fputc(0x18,fw);
	writezeros(9);
	fputc(0x12,fw);
	fputc(0x0b,fw);
	writezeros(2);
	fputc(0x12,fw);
	fputc(0x0b,fw);
	writezeros(10);
}

//-----------------------------------------------------------------------------
// Name: writepicture
// Desc: Writes the corresponding color in the bitmap
//-----------------------------------------------------------------------------

void LZW2BMP::writepicture(int pic){
	switch(pic){
	case 0://white
		fputc(0,fw);
		fputc(0,fw);
		fputc(0,fw);
		break;
	case 1://dark blue
		fputc(160,fw);
		fputc(0,fw);
		fputc(0,fw);
		break;
	case 2://dark green
		fputc(0,fw);
		fputc(160,fw);
		fputc(0,fw);
		break;
	case 3://blue green
		fputc(160,fw);
		fputc(160,fw);
		fputc(0,fw);
		break;
	case 4://maroon
		fputc(0,fw);
		fputc(0,fw);
		fputc(160,fw);
		break;
	case 5://dark purple
		fputc(160,fw);
		fputc(0,fw);
		fputc(160,fw);
		break;
	case 6://brown
		fputc(0,fw);
		fputc(80,fw);
		fputc(160,fw);
		break;
	case 7://light grey
		fputc(160,fw);
		fputc(160,fw);
		fputc(160,fw);
		break;
	case 8://dark grey
		fputc(80,fw);
		fputc(80,fw);
		fputc(80,fw);
		break;
	case 9://blue
		fputc(255,fw);
		fputc(0,fw);
		fputc(0,fw);
		break;
	case 10://light green
		fputc(80,fw);
		fputc(255,fw);
		fputc(80,fw);
		break;
	case 11://light blue
		fputc(255,fw);
		fputc(255,fw);
		fputc(80,fw);
		break;
	case 12://light red
		fputc(80,fw);
		fputc(80,fw);
		fputc(255,fw);
		break;
	case 13://light purple
		fputc(255,fw);
		fputc(80,fw);
		fputc(255,fw);
		break;
	case 14://yellow
		fputc(80,fw);
		fputc(255,fw);
		fputc(255,fw);
		break;
	case 15://black
		fputc(255,fw);
		fputc(255,fw);
		fputc(255,fw);
		break;
	default:
		break;
	}
}

//-----------------------------------------------------------------------------
// Name: writecreatelzw
// Desc: Opens create.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writecreatelzw(){
	if((fp = fopen(".//game//other//create.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("create",0,50,fp,168,96);
	writebmplzw1("create",1,4,fp,240,74);
	writebmplzw1("create",2,4,fp,56,67);
	writebmplzw1("create",3,4,fp,48,67);
	writebmplzw1("create",4,4,fp,40,69);
	writebmplzw1("create",5,4,fp,56,58);
	writebmplzw1("create",6,4,fp,48,61);
	writebmplzw1("create",7,4,fp,48,64);
	writebmplzw1("create",8,4,fp,56,65);
	writebmplzw1("create",9,4,fp,48,65);
	writebmplzw1("create",10,4,fp,152,100);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writednglzw
// Desc: Opens dng*.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writednglzw(char* dng){
	char dngfile[_MAX_PATH];
	sprintf(dngfile,".//game//other//%s.lzw",dng);
	if((fp = fopen(dngfile,"rb"))==NULL){
		return;
	}
	writebmplzw1(dng,0,118,fp,24,164);
	writebmplzw1(dng,1,4,fp,32,164);
	writebmplzw1(dng,2,4,fp,16,164);
	writebmplzw1(dng,3,4,fp,8,164);
	writebmplzw1(dng,4,4,fp,24,164);
	writebmplzw1(dng,5,4,fp,32,164);
	writebmplzw1(dng,6,4,fp,16,164);
	writebmplzw1(dng,7,4,fp,8,164);
	writebmplzw1(dng,8,4,fp,56,164);
	writebmplzw1(dng,9,4,fp,24,164);
	writebmplzw1(dng,10,4,fp,8,164);
	writebmplzw1(dng,11,4,fp,80,164);
	writebmplzw1(dng,12,4,fp,56,164);
	writebmplzw1(dng,13,4,fp,24,164);
	writebmplzw1(dng,14,4,fp,8,164);
	writebmplzw1(dng,15,4,fp,24,164);
	writebmplzw1(dng,16,4,fp,32,164);
	writebmplzw1(dng,17,4,fp,16,164);
	writebmplzw1(dng,18,4,fp,8,164);
	writebmplzw1(dng,19,4,fp,24,164);
	writebmplzw1(dng,20,4,fp,32,164);
	writebmplzw1(dng,21,4,fp,16,164);
	writebmplzw1(dng,22,4,fp,8,164);
	writebmplzw1(dng,23,4,fp,56,164);
	writebmplzw1(dng,24,4,fp,24,164);
	writebmplzw1(dng,25,4,fp,8,164);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writeendsclzw
// Desc: Opens endsc.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writeendsclzw(){
	if((fp = fopen(".//game//other//endsc.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("endsc",0,10,fp,264,168);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writeend1lzw
// Desc: Opens end1.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writeend1lzw(){
	if((fp = fopen(".//game//other//end1.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("end1",0,18,fp,168,124);
	writebmplzw1("end1",1,4,fp,192,90);
	writebmplzw1("end1",2,4,fp,192,95);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writeend2lzw
// Desc: Opens end2.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writeend2lzw(){
	if((fp = fopen(".//game//other//end2.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("end2",0,18,fp,176,98);
	writebmplzw1("end2",1,4,fp,160,90);
	writebmplzw1("end2",2,4,fp,160,110);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writeitemslzw
// Desc: Opens items.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writeitemslzw(){
	if((fp = fopen(".//game//other//items.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("items",0,86,fp,40,80);
	writebmplzw1("items",1,4,fp,10,80,true);
	writebmplzw1("items",2,4,fp,24,56);
	writebmplzw1("items",3,4,fp,6,56,true);
	writebmplzw1("items",4,4,fp,16,24);
	writebmplzw1("items",5,4,fp,4,24,true);
	writebmplzw1("items",6,4,fp,8,8);
	writebmplzw1("items",7,4,fp,2,8,true);
	writebmplzw1("items",8,4,fp,40,80);
	writebmplzw1("items",9,4,fp,10,80,true);
	writebmplzw1("items",10,4,fp,24,56);
	writebmplzw1("items",11,4,fp,6,56,true);
	writebmplzw1("items",12,4,fp,16,24);
	writebmplzw1("items",13,4,fp,4,24,true);
	writebmplzw1("items",14,4,fp,8,8);
	writebmplzw1("items",15,4,fp,2,8,true);
	writebmplzw1("items",16,4,fp,40,24);
	writebmplzw1("items",17,4,fp,10,24,true);
	writebmplzw1("items",18,4,fp,24,32);
	writebmplzw1("items",19,4,fp,6,32,true);
	writebmplzw1("items",20,4,fp,16,16);
	writebmplzw1("items",21,4,fp,4,16,true);
	writebmplzw1("items",22,4,fp,8,8);
	writebmplzw1("items",23,4,fp,2,8,true);
	writebmplzw1("items",24,4,fp,40,24);
	writebmplzw1("items",25,4,fp,10,24,true);
	writebmplzw1("items",26,4,fp,24,32);
	writebmplzw1("items",27,4,fp,6,32,true);
	writebmplzw1("items",28,4,fp,16,16);
	writebmplzw1("items",29,4,fp,4,16,true);
	writebmplzw1("items",30,4,fp,8,8);
	writebmplzw1("items",31,4,fp,2,8,true);
	writebmplzw1("items",32,4,fp,40,24);
	writebmplzw1("items",33,4,fp,10,24,true);
	writebmplzw1("items",34,4,fp,24,32);
	writebmplzw1("items",35,4,fp,6,32,true);
	writebmplzw1("items",36,4,fp,16,16);
	writebmplzw1("items",37,4,fp,4,16,true);
	writebmplzw1("items",38,4,fp,16,16);
	writebmplzw1("items",39,4,fp,4,16,true);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writemonlzw
// Desc: Opens mon*.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writemonlzw(char* mon){
	char monfile[_MAX_PATH];
	sprintf(monfile,".//game//other//%s.lzw",mon);
	if((fp = fopen(monfile,"rb"))==NULL){
		return;
	}

	writebmplzw1(mon,0,30,fp,24,66);
	writebmplzw1(mon,1,4,fp,6,66,true);
	writebmplzw1(mon,2,4,fp,16,25);
	writebmplzw1(mon,3,4,fp,4,26,true);
	writebmplzw1(mon,4,2,fp,8,6);
	writebmplzw1(mon,5,14,fp,24,66);
	writebmplzw1(mon,6,4,fp,6,66,true);
	writebmplzw1(mon,7,4,fp,16,25);
	writebmplzw1(mon,8,4,fp,4,25,true);
	writebmplzw1(mon,9,4,fp,8,6);
	fclose(fp);
}


//-----------------------------------------------------------------------------
// Name: writestartsclzw
// Desc: Opens startsc.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestartsclzw(){
	if((fp = fopen(".//game//other//startsc.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("startsc",0,18,fp,16,137);
	writebmplzw1("startsc",1,4,fp,288,137);
	writebmplzw1("startsc",2,4,fp,16,137);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writestory1lzw
// Desc: Opens story1.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestory1lzw(){
	if((fp = fopen(".//game//other//story1.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("story1",0,18,fp,176,192);
	writebmplzw1("story1",1,4,fp,168,126);
	writebmplzw1("story1",2,4,fp,48,33);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writestory2lzw
// Desc: Opens story2.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestory2lzw(){
	if((fp = fopen(".//game//other//story2.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("story2",0,22,fp,184,131);
	writebmplzw1("story2",1,4,fp,200,121);
	writebmplzw1("story2",2,4,fp,168,124);
	writebmplzw1("story2",3,4,fp,128,115);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writestory3lzw
// Desc: Opens story3.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestory3lzw(){
	if((fp = fopen(".//game//other//story3.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("story3",0,14,fp,184,167);
	writebmplzw1("story3",1,4,fp,320,118);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writestory4lzw
// Desc: Opens story4.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestory4lzw(){
	if((fp = fopen(".//game//other//story4.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("story4",0,14,fp,320,118);
	writebmplzw1("story4",1,4,fp,320,118);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writestory5lzw
// Desc: Opens story5.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestory5lzw(){
	if((fp = fopen(".//game//other//story5.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("story5",0,14,fp,320,118);
	writebmplzw1("story5",1,4,fp,320,118);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writestory6lzw
// Desc: Opens story6.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writestory6lzw(){
	if((fp = fopen(".//game//other//story6.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("story6",0,38,fp,144,112);
	writebmplzw1("story6",1,4,fp,176,113);
	writebmplzw1("story6",2,4,fp,144,55);
	writebmplzw1("story6",3,4,fp,144,39);
	writebmplzw1("story6",4,4,fp,144,55);
	writebmplzw1("story6",5,4,fp,144,39);
	writebmplzw1("story6",6,4,fp,144,55);
	writebmplzw1("story6",7,4,fp,144,38);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writetextlzw
// Desc: Opens text.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writetextlzw(){
	if((fp = fopen(".//game//other//text.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("text",0,58,fp,56,31);
	writebmplzw1("text",1,4,fp,152,32);
	writebmplzw1("text",2,4,fp,104,32);
	writebmplzw1("text",3,4,fp,72,32);
	writebmplzw1("text",4,4,fp,168,33);
	writebmplzw1("text",5,4,fp,96,33);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writetileslzw
// Desc: Opens tiles.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writetileslzw(){
	if((fp = fopen(".//game//other//tiles.lzw","rb"))==NULL){
		return;
	}
	fw = fopen(".//game//pictures//tiles.bmp","wb");
	writebitmap(512,256,false,32,16);
	fclose(fw);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: writeultimalzw
// Desc: Opens ultima.lzw and draws its contents
//-----------------------------------------------------------------------------

void LZW2BMP::writeultimalzw(){
	if((fp = fopen(".//game//other//ultima.lzw","rb"))==NULL){
		return;
	}
	writebmplzw1("ultima",0,26,fp,320,61);
	writebmplzw1("ultima",1,4,fp,288,49);
	writebmplzw1("ultima",2,4,fp,288,49);
	writebmplzw1("ultima",3,4,fp,288,49);
	writebmplzw1("ultima",4,4,fp,288,49);
	fclose(fp);
}

//-----------------------------------------------------------------------------
// Name: ~PICTURES()
// Desc: Frees the array of pixels
//-----------------------------------------------------------------------------

PICTURES::~PICTURES(){
	if(initialized == false){
		return;
	}
	for(int a = 0; a < width; a++){
		free(pixels[a]);
	}
	free(pixels);
}

//-----------------------------------------------------------------------------
// Name: ~PICTURES()
// Desc: Frees the array of pixels
//-----------------------------------------------------------------------------

void PICTURES::init(){

	pixels = (int**)malloc(sizeof(int)*width);
	for(int a = 0; a < width; a++){
		pixels[a] = (int*)malloc(sizeof(int)*height);
	}
	initialized = true;
}

//-----------------------------------------------------------------------------
// Name: writezeros
// Desc: Write zeros to the file
//-----------------------------------------------------------------------------

void PICTURES::writezeros(int numzero){
	for(int a = 0; a < numzero; a++){
		fputc(0x00,fw);
	}
}
/*
//-----------------------------------------------------------------------------
// Name: main()
// Desc: 
//-----------------------------------------------------------------------------

void main(){
	LZW2BMP *lzw2bmp;
	BMP2LZW *bmp2lzw;
	cout<<"Press 1 to create bitmaps out of *.lzw files"<<endl;
	cout<<"Press 2 to create *.lzw files out of bitmaps"<<endl;
	cout<<"All other keys quit"<<endl;
	int x = getchar();
	switch(x){
	case '1':
		lzw2bmp = new LZW2BMP();
		delete lzw2bmp;
		break;
	case '2':
		bmp2lzw = new BMP2LZW();
		delete bmp2lzw;
		break;
	default:
		break;
	}
}*/