#ifndef PICTURES_H
#define PICTURES_H

class PICTURES;
class BMP2LZW;
class LZW2BMP;

class PICTURES{
protected:
	void init();
	void writezeros(int numzero);

	FILE *fp;
	FILE *fw;
	
	bool initialized;

	int **pixels;

	int height;
	int numxtiles;
	int numytiles;
	int tileheight;
	int tilewidth;
	int width;
public:
	PICTURES(){initialized = false;}
	~PICTURES();
};

class BMP2LZW : PICTURES{
private:
	int getpicture();
	void getdat();
	void getheader();
	void writedat();
	void writelzw(int width1, int height1, int tilewidth1,
				 int tileheight1, int numxtiles1, int numytiles1);

	void writetileslzw();
	void writeultimalzw();
public:
	BMP2LZW(){
		writetileslzw();
		writeultimalzw();
	}
	~BMP2LZW(){}
};

class LZW2BMP : PICTURES{
private:
	void drawdat();
	void writebitmap(int width1, int height1, bool mask,
		int numxtiles1, int numytiles1);
	void writebmplzw1(char* bmp, int num, int seek1, FILE *fp,
						   int width1, int height1, bool mask);
	void writedat(bool mask);
	void writeend();
	void writeheader();
	void writepicture(int pic);

	void writecreatelzw();
	void writednglzw(char* dng);
	void writeendsclzw();
	void writeend1lzw();
	void writeend2lzw();
	void writeitemslzw();
	void writemonlzw(char* mon);
	void writestartsclzw();
	void writestory1lzw();
	void writestory2lzw();
	void writestory3lzw();
	void writestory4lzw();
	void writestory5lzw();
	void writestory6lzw();
	void writetextlzw();
	void writetileslzw();
	void writeultimalzw();
public:
	LZW2BMP(){
		writecreatelzw();
		writednglzw("dng1");
		writednglzw("dng2");
		writednglzw("dng3");
		writeendsclzw();
		writeend1lzw();
		writeend2lzw();
		writeitemslzw();
		writemonlzw("mon0");
		writemonlzw("mon1");
		writemonlzw("mon2");
		writemonlzw("mon3");
		writemonlzw("mon4");
		writemonlzw("mon5");
		writemonlzw("mon6");
		writemonlzw("mon7");
		writestartsclzw();
		writestory1lzw();
		writestory2lzw();
		writestory3lzw();
		writestory4lzw();
		writestory5lzw();
		writestory6lzw();
		writetextlzw();
		writetileslzw();
		writeultimalzw();
	}
	~LZW2BMP(){}
};

#endif