#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>

FILE* ftlk = NULL;
FILE* ftxt = NULL;
unsigned short* offsets = NULL;

void writenewline()
{
	char strnum[8];

	sprintf(strnum, "\r\n");
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
}

unsigned short processnumentries()
{
	unsigned short numentries;
	char strnum[128];

	fread(&numentries, sizeof(unsigned short), 1, ftlk);
	sprintf(strnum, "Number of entries: %d", numentries);
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
	writenewline();
	writenewline();
	writenewline();

	return numentries;
}

void processheaders(unsigned short numentries)
{
	int index;
	unsigned short npcnum;
	unsigned short scriptoffset;
	char strnum[128];

	offsets = (unsigned short*)malloc(sizeof(unsigned short) * numentries);
	for(index = 0; index < numentries; index++)
	{
		fread(&npcnum, sizeof(unsigned short), 1, ftlk);
		fread(&scriptoffset, sizeof(unsigned short), 1, ftlk);
		offsets[index] = scriptoffset;

		sprintf(strnum, "NPC Number: %d", npcnum);
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		sprintf(strnum, "Script Offset: %d", scriptoffset);
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		writenewline();
	}

	writenewline();
}

void processwritename()
{
	char strnum[128];
	writenewline();
	sprintf(strnum, "Name: ");
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
}

void processwritedescription(int scriptnum)
{
	char strnum[128];
	switch(scriptnum)
	{
	case -9:
		sprintf(strnum, "<Label 5>");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		break;
	case -8:
		sprintf(strnum, "<Other Response>");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		fgetc(ftlk);
		break;
	case -7:
		sprintf(strnum, "<Label 4>");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		break;
	case -6:
		sprintf(strnum, "<Label 3>");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		break;
	case -5:
		sprintf(strnum, "<Label 2>");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		break;
	case -4:
		sprintf(strnum, "<Label 1>");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		break;
	case -3:
		sprintf(strnum, "----------------------------------------------------------------------");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	case -2:
		sprintf(strnum, "or");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	case -1:
		sprintf(strnum, "Keyword: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	case 0:
		sprintf(strnum, "You see: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	case 1:
		sprintf(strnum, "Greeting: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	case 2:
		sprintf(strnum, "Job: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	case 3:
		sprintf(strnum, "Bye: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		break;
	default:
		break;
	}
}

void processwritelabel()
{
	char strnum[128];
	unsigned char labelnum;
	unsigned char labeltype;
	labelnum = fgetc(ftlk);
	labeltype = fgetc(ftlk);
	writenewline();
	switch(labeltype)
	{
	case 0:
		sprintf(strnum, "<End Conversation>", labelnum);
		break;
	case 131:
		sprintf(strnum, "<Pause>", labelnum);
		break;
	case 140:
		sprintf(strnum, "<Set Flag 1>", labelnum);
		break;
	case 141:
		sprintf(strnum, "<Pause>", labelnum);
		break;
	case 143:
		switch(labelnum)
		{
		case 141:
			sprintf(strnum, "<Wait for key...>");
			break;
		}
		break;
	case 145:
		sprintf(strnum, "<Label 1>");
		break;
	case 162:
		return;
		break;
	default:
		sprintf(strnum, "<Unknown: %d>", labelnum);
		break;
	}
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
	writenewline();
}

void processdecode()
{
	int c = 0;
	int curpos;
	int curentry = 0;
	unsigned short numentries;
	bool phrase = false;
	int writedescript = -1;
	int keyword = 0;
	bool justwrotedescript = false;

	numentries = processnumentries();
	processheaders(numentries);

	curpos = 1 + (4 * numentries);
	while(1)
	{
		curpos++;
		phrase=false;
		c=fgetc(ftlk);
		if(!feof(ftlk))
		{
			switch(c)
			{
			case 0:
				{
					writenewline();
					if(0 <= writedescript)
					{
						processwritedescription(writedescript);
						writedescript++;
						if(4 < writedescript)
						{
							writedescript = -1;
							writenewline();

							processwritedescription(-1);
							keyword = 0;
						}
					}
					else
					{
						if(keyword == 0)
						{
							keyword = 1;
							justwrotedescript = true;
						}
						else
						{
							keyword = 2;
						}
					}
					continue;
				}
				break;
			case 134:
				processwritedescription(-8);
				keyword = 0;
				curpos++;
				continue;
			case 135:
				if(true == justwrotedescript)
				{
					processwritedescription(-2);
					justwrotedescript = false;
				}
				continue;
				break;
			case 141:
				processwritelabel();
				curpos += 2;
				continue;
				break;
			case 144:
			case 159:
				continue;
			case 145:
				keyword = 0;
				processwritedescription(-4);
				continue;
			case 146:
				keyword = 0;
				processwritedescription(-5);
				continue;
			case 147:
				keyword = 0;
				processwritedescription(-6);
				continue;
			case 148:
				keyword = 0;
				processwritedescription(-7);
				continue;
			case 149:
				keyword = 0;
				processwritedescription(-9);
				continue;
			case 192:
				writenewline();
				processwritedescription(-3);
				writenewline();
				keyword = 0;
				continue;
			default:
				break;
			}

			if(keyword == 2)
			{
				processwritedescription(-1);
				keyword = 0;
				justwrotedescript = true;
			}

			if(curpos == offsets[curentry])
			{
				justwrotedescript = false;
				processwritename();
				curentry++;
				writedescript = 0;
			}
			if(c>=166&&c<=218)
			{
				c -= 128;
			}
			else if(c>=225&&c<=250)
			{
				c -= 128;
			}
			else if(c == 161)
			{
				c -= 128;
			}
			else if(c==8||c==28||c==50||c==65||c==67||
				c==70||c==72||c==73||c==74||c==75||c==130||
				c==131||c==132||c>250)
			{
				c=0;
			}
			else if(c>=137&&c<=144){
				c=0;
			}
			else if(c>=147&&c<=165){
				c=0;
			}
			else{
				phrase=true;
			}
			if(phrase==false){
				fputc(c,ftxt);
			}
			if(phrase==true){
				if(c==0){
					fputc(13,ftxt);
					fputc(10,ftxt);
				}
				if(c==1){
					fputs(" the ",ftxt);
				}
				if(c==2){
					fputs(" though ",ftxt);
				}
				if(c==3){
					fputs(" of ",ftxt);
				}
				if(c==4){
					fputs(" to ",ftxt);
				}
				if(c==5){
					fputs(" and ",ftxt);
				}
				if(c==6){
					fputs(" that ",ftxt);
				}
				if(c==7){
					fputs(" for ",ftxt);
				}
				if(c==9){
					fputs(" in ",ftxt);
				}
				if(c==10){
					fputs(" is ",ftxt);
				}
				if(c==11){
					fputs(" have ",ftxt);
				}
				if(c==12){
					fputs(" with ",ftxt);
				}
				if(c==13){
					fputs(" thee ",ftxt);
				}
				if(c==14){
					fputs(" this ",ftxt);
				}
				if(c==15){
					fputs(" not ",ftxt);
				}
				if(c==16){
					fputs(" my ",ftxt);
				}
				if(c==17){
					fputs(" it ",ftxt);
				}
				if(c==18){
					fputs(" me ",ftxt);
				}
				if(c==19){
					fputs(" but ",ftxt);
				}
				if(c==20){
					fputs(" dost ",ftxt);
				}
				if(c==21){
					fputs(" know ",ftxt);
				}
				if(c==22){
					fputs(" be ",ftxt);
				}
				if(c==23){
					fputs(" was ",ftxt);
				}
				if(c==24){
					fputs(" Blackthorn ",ftxt);
				}
				if(c==25){
					fputs(" from ",ftxt);
				}
				if(c==26){
					fputs(" thy ",ftxt);
				}
				if(c==27){
					fputs(" one ",ftxt);
				}
				if(c==29){
					fputs(" are ",ftxt);
				}
				if(c==30){
					fputs(" here ",ftxt);
				}
				if(c==31){
					fputs(" many ",ftxt);
				}
				if(c==32){
					fputs(" Lord ",ftxt);
				}
				if(c==33){
					fputs(" am ",ftxt);
				}
				if(c==34){
					fputs(" we ",ftxt);
				}
				if(c==35){
					fputs(" they ",ftxt);
				}
				if(c==36){
					fputs(" he ",ftxt);
				}
				if(c==37){
					fputs(" would ",ftxt);
				}
				if(c==38){
					fputs(" art ",ftxt);
				}
				if(c==39){
					fputs(" on ",ftxt);
				}
				if(c==40){
					fputs(" young ",ftxt);
				}
				if(c==41){
					fputs(" what ",ftxt);
				}
				if(c==42){
					fputs(" see ",ftxt);
				}
				if(c==43){
					fputs(" like ",ftxt);
				}
				if(c==44){
					fputs(" only ",ftxt);
				}
				if(c==45){
					fputs(" by ",ftxt);
				}
				if(c==46){
					fputs(" there ",ftxt);
				}
				if(c==47){
					fputs(" Blackthorn's ",ftxt);
				}
				if(c==48){
					fputs(" good ",ftxt);
				}
				if(c==49){
					fputs(" been ",ftxt);
				}
				if(c==51){
					fputs(" must ",ftxt);
				}
				if(c==52){
					fputs(" his ",ftxt);
				}
				if(c==53){
					fputs(" British ",ftxt);
				}
				if(c==54){
					fputs(" fine ",ftxt);
				}
				if(c==55){
					fputs(" an ",ftxt);
				}
				if(c==56){
					fputs(" great ",ftxt);
				}
				if(c==57){
					fputs(" thee ",ftxt);
				}
				if(c==58){
					fputs(" our ",ftxt);
				}
				if(c==59){
					fputs(" who ",ftxt);
				}
				if(c==60){
					fputs(" name ",ftxt);
				}
				if(c==61){
					fputs(" heard ",ftxt);
				}
				if(c==62){
					fputs(" as ",ftxt);
				}
				if(c==63){
					fputs(" at ",ftxt);
				}
				if(c==64){
					fputs(" has ",ftxt);
				}
				if(c==66){
					fputs(" through ",ftxt);
				}
				if(c==68){
					fputs(" once ",ftxt);
				}
				if(c==69){
					fputs(" can ",ftxt);
				}
				if(c==71){
					fputs(" him ",ftxt);
				}
				if(c==76){
					fputs(" ye ",ftxt);
				}
				if(c==77){
					fputs(" Shadowlords ",ftxt);
				}
				if(c==78){
					fputs(" tell ",ftxt);
				}
				if(c==79){
					fputs(" some ",ftxt);
				}
				if(c==80){
					fputs(" believe ",ftxt);
				}
				if(c==81){
					fputs(" all ",ftxt);
				}
				if(c==82){
					fputs(" thier ",ftxt);
				}
				if(c==83){
					fputs(" upon ",ftxt);
				}
				if(c==84){
					fputs(" even ",ftxt);
				}
				if(c==85){
					fputs(" 'tis ",ftxt);
				}
				if(c==86){
					fputs(" find ",ftxt);
				}
				if(c==87){
					fputs(" if ",ftxt);
				}
				if(c==88){
					fputs(" about ",ftxt);
				}
				if(c==89){
					fputs(" don't ",ftxt);
				}
				if(c==90){
					fputs(" before ",ftxt);
				}
				if(c==91){
					fputs(" these ",ftxt);
				}
				if(c==92){
					fputs(" just ",ftxt);
				}
				if(c==93){
					fputs(" make ",ftxt);
				}
				if(c==94){
					fputs(" will ",ftxt);
				}
				if(c==95){
					fputs(" when ",ftxt);
				}
				if(c==96){
					fputs(" three ",ftxt);
				}
				if(c==97){
					fputs(" Great ",ftxt);
				}
				if(c==98){
					fputs(" might ",ftxt);
				}
				if(c==99){
					fputs(" those ",ftxt);
				}
				if(c==100){
					fputs(" old ",ftxt);
				}
				if(c==101){
					fputs(" hast ",ftxt);
				}
				if(c==102){
					fputs(" ask ",ftxt);
				}
				if(c==103){
					fputs(" unto ",ftxt);
				}
				if(c==104){
					fputs(" wish ",ftxt);
				}
				if(c==105){
					fputs(" man ",ftxt);
				}
				if(c==106){
					fputs(" so ",ftxt);
				}
				if(c==107){
					fputs(" knows ",ftxt);
				}
				if(c==108){
					fputs(" still ",ftxt);
				}
				if(c==109){
					fputs(" Mantra ",ftxt);
				}
				if(c==110){
					fputs(" out ",ftxt);
				}
				if(c==111){
					fputs(" help ",ftxt);
				}
				if(c==112){
					fputs(" well ",ftxt);
				}
				if(c==113){
					fputs(" shall ",ftxt);
				}
				if(c==114){
					fputs(" think ",ftxt);
				}
				if(c==115){
					fputs(" where ",ftxt);
				}
				if(c==116){
					fputs(" named ",ftxt);
				}
				if(c==117){
					fputs(" talking ",ftxt);
				}
				if(c==118){
					fputs(" more ",ftxt);
				}
				if(c==119){
					fputs(" such ",ftxt);
				}
				if(c==120){
					fputs(" very ",ftxt);
				}
				if(c==121){
					fputs(" many ",ftxt);
				}
				if(c==122){
					fputs(" lives ",ftxt);
				}
				if(c==123){
					fputs(" canst ",ftxt);
				}
				if(c==124){
					fputs(" which ",ftxt);
				}
				if(c==125){
					fputs(" since ",ftxt);
				}
				if(c==126){
					fputs(" need ",ftxt);
				}
				if(c==127){
					fputs(" I've ",ftxt);
				}
				if(c==128){
					fputs(" work ",ftxt);
				}
				if(c==129){
					fputs(" <insert Avatar's name here> ",ftxt);
				}
				if(c==133){
					fputs(" Though hast not enough gold! ",ftxt);
				}
				if(c==134){
					fputs(" What is thy name? ",ftxt);
				}
				if(c==135){
					fputs(" Until morrow ",ftxt);
				}
				if(c==136){
					fputs(" What is thy name? ",ftxt);
				}
				if(c==145){
					fputs(" Who dost thou think is the rightful ruler of Britannia? ",ftxt);
				}
				if(c==146){
					fputs(" What Mantra dost thou seek? ",ftxt);
				}
			}



			
		}
		else
		{
			break;
		}
	}
}

void decodefile(const char* filename)
{
	char tlkfile[16];
	char txtfile[16];

	sprintf(tlkfile, "%s.tlk", filename);
	sprintf(txtfile, "%s.txt", filename);

	if((ftlk = fopen(tlkfile, "rb") ) == NULL)
	{
		return;
	}

	if((ftxt = fopen(txtfile, "wb") ) == NULL)
	{
		fclose(ftlk);
		return;
	}

	processdecode();

	if(NULL != offsets)
	{
		free(offsets);
		offsets = NULL;
	}

	fclose(ftlk);
	fclose(ftxt);
}

int main()
{
	int done = 0;
	int index;
	int numFiles;
	int keyhit;

	const char* tlkFileNames[] = {"Castle", "Dwelling", "Keep", "Towne"};

	numFiles = (sizeof(tlkFileNames)) / sizeof(char*);

	while (!done)
	{
		system("cls");

		printf("The files must be in the same directory as this executable!\n");
		printf("I suggest adding the *.tlk files and this executable OUTSIDE the U5 directory!\n\n");

		for(index = 0; index < numFiles; index++)
		{
			printf("%d: Decode %s.tlk\n", index + 1, tlkFileNames[index]);
		}
		printf("%d: Exit\n", numFiles + 1);

		_kbhit();
		keyhit = getch();

		keyhit -= '1';

		if(keyhit >= 0 && keyhit < numFiles)
		{
			decodefile(tlkFileNames[keyhit]);
		}
		else if(keyhit == numFiles)
		{
			done = true;
		}
	}
	return 0;
}